//
//     Copyright (C) 2003 - 2008 Sophia Cradle Incorporated
//     All rights reserved.
//
//     File: MainWindow.cpp
//

#include "MainWindow.hpp"
#include "ContentWindow.hpp"
#include "cartoon_sfy_frame.hpp"

// RXgN^
MainWindow::MainWindow() static_throws
{
    if (static_try()) {
        // y[Wԍ̏
        page_number = 0;

        // tH[JXړL[̐ݒ
        SetScrollDownKey(AVK_RIGHT);
        SetScrollUpKey(AVK_LEFT);
    }
}

// fXgN^
MainWindow::~MainWindow()
{
}

// NewInstance() ֐
MainWindowSmp MainWindow::NewInstance(SFCErrorPtr exception)
{
    return static_pointer_cast<MainWindow>(Factory(::new MainWindow, exception));
}

// CEBhẼX|_̍쐬Ɣzu
Void MainWindow::Make()
{
    SFXSize region_size;
    SFCError error = SFERR_NO_ERROR;

    // CEBhË̃TCY擾
    region_size = GetLocalBound().GetSize();

    // rbg}bvg嗦ݒ肷
    if (200 <= region_size.GetWidth()) {
        // CEBhE̎̈̉TCY 200 sNZȏ̏ꍇ
        expansion_ratio = 2;  // rbg}bvg嗦 2 {ɐݒ
    }
    else {
        // CEBhE̎̈̉TCY 200菬ꍇ
        expansion_ratio = 1;  // rbg}bvg嗦 1 {ɐݒ
    }

    // RecEBhEƃCEBhEԂ̗]sNZvZ
    SIntN margin1 = (GetLocalBound().GetWidth() - PICTSIZE ) / 2;

    // RecEBhEƃ{^̊Ԃ̗]sNZvZ
    SIntN margin2 = (GetLocalBound().GetHeight() - margin1 - PICTSIZE - BUTTON_HEIGHT ) / 2;

    // {^Ԃ̃ItZbgl
    SIntN button_offset = BUTTON_WIDTH + (GetLocalBound().GetWidth() - margin1 * 2 - BUTTON_WIDTH * 3 ) / 2;

    // RecEBhE𐶐
    _windowContent = ContentWindow::NewInstance(&error);
    if (error == SFERR_NO_ERROR){
        // RecEBhE̐eCEBhEɐݒ肷
        error = _windowContent->SetParent(GetThis());
        if (error == SFERR_NO_ERROR){
            // RecEBhE̎̈ݒ肷
            _windowContent->SetRealBound(GetLocalBound().SetHeight(margin1 * 2 + PICTSIZE).Deflate(margin1, margin1));
            // RecEBhȄԂu{{s\{tH[JXvɂ܂Ƃ߂Đݒ肷
            _windowContent->SetState(true,true,false,false);
            // ŏɕ\y[Wԍ
            _windowContent->SetPage(0);
            // RecEBhEőOʂɈړ
            _windowContent->ToFront();
        }
    }

    // RecEBhEł́uOŁv{^̋`̈
    SFXRectangle button_region = SFXRectangle(margin1, margin1+ PICTSIZE + margin2 , BUTTON_WIDTH, BUTTON_HEIGHT);

    //uOŁv{^̍쐬
    _buttonPrev = SFZTextButtonControl::NewInstance(&error);
    if (error == SFERR_NO_ERROR) {
        //uOŁv{^̐eCEBhEɐݒ肷
        _buttonPrev->SetParent(GetThis());
        //uOŁv{^̎̈ݒ肷
        _buttonPrev->SetRealBound(button_region);
        //uOŁv{^̃xݒ肷
        _buttonPrev->SetText(TEXT_PREV);
        //uOŁv{^̏Ԃu{{\{tH[JXvɂ܂Ƃ߂Đݒ肷
        _buttonPrev->SetState(true,true,true,false);
        //uOŁv{^̃nho^
        _buttonPrev->RegisterHandler(SFXEventRange(SFEVT_RESPONDER_RESULT, SFEVT_RESPONDER_RESULT, SFP16_BEGIN, SFP16_END),
                                     XANDLER_INTERNAL(OnButtonControlPrev));
    }

    //ugv{^̍쐬
    _buttonZoom = SFZTextButtonControl::NewInstance(&error);
    if (error == SFERR_NO_ERROR) {
        //ugv{^̐eCEBhEɐݒ肷
        _buttonZoom->SetParent(GetThis());
        //ugv{^̎̈ݒ肷
        _buttonZoom->SetRealBound(button_region.Offset(button_offset, 0));
        //ugv{^̃xݒ肷
        _buttonZoom->SetText(TEXT_ZOOM);
        //ugv{^̏Ԃu{{\{tH[JXvɂ܂Ƃ߂Đݒ肷
        _buttonZoom->SetState(true,true,true,false);
        //ugv{^̃nho^
        _buttonZoom->RegisterHandler(SFXEventRange(SFEVT_RESPONDER_RESULT, SFEVT_RESPONDER_RESULT, SFP16_BEGIN, SFP16_END),
                                     XANDLER_INTERNAL(OnButtonControlZoom));
    }

    //uŁv{^̍쐬
    _buttonNext = SFZTextButtonControl::NewInstance(&error);
    if (error == SFERR_NO_ERROR) {
        //uŁv{^̐eCEBhEɐݒ肷
        _buttonNext->SetParent(GetThis());
        //uŁv{^̎̈ݒ肷
        _buttonNext->SetRealBound(button_region.Offset(button_offset, 0));
        //uŁv{^̃xݒ肷
        _buttonNext->SetText(TEXT_NEXT);
        //uŁv{^̏Ԃu{{\{tH[JXvɂ܂Ƃ߂Đݒ肷
        _buttonNext->SetState(true,true,true,true);
        //uŁv{^̃nho^
        _buttonNext->RegisterHandler(SFXEventRange(SFEVT_RESPONDER_RESULT, SFEVT_RESPONDER_RESULT, SFP16_BEGIN, SFP16_END),
                                     XANDLER_INTERNAL(OnButtonControlNext));
    }
    // uOŁv{^sԂɏ
    _buttonPrev->SetStateVisible(false);
    // ugv{^sԂɏ
    _buttonZoom->SetStateVisible(false);
}

//uŁv{^̃nh
XANDLER_IMPLEMENT_VOIDRESULT(MainWindow, OnButtonControlNext, invoker, result, control)
{
    unused(invoker);
    unused(result);
    unused(control);

    // RecEBhEɕ\y[Wԍݒ肷
    _windowContent->SetPage(++page_number);

    // {^̏ԂXV
    if (page_number == 1) {
            _buttonPrev->SetStateVisible(true);
            _buttonZoom->SetStateVisible(true);
    }
    else if (page_number == PICTS_NUMBER + 1) {
            _buttonPrev->SetStateVisible(true);
            _buttonZoom->SetStateVisible(false);
            _buttonNext->SetStateVisible(false);
    }
}

//uOŁv{^̃nh
XANDLER_IMPLEMENT_VOIDRESULT(MainWindow, OnButtonControlPrev, invoker, result, control)
{
    unused(result);
    unused(control);
    unused(invoker);

    // RecEBhEɕ\y[Wԍݒ肷
    _windowContent->SetPage(--page_number);

    // {^̏ԂXV
    if (page_number == 0) {
            _buttonPrev->SetStateVisible(false);
            _buttonZoom->SetStateVisible(false);
            _buttonNext->SetStateVisible(true);
    }
    else if (page_number == PICTS_NUMBER) {
            _buttonZoom->SetStateVisible(true);
            _buttonNext->SetStateVisible(true);
    }
}

//ugv{^̃nh
XANDLER_IMPLEMENT_VOIDRESULT(MainWindow, OnButtonControlZoom, invoker, result, control)
{
    unused(result);
    unused(control);
    unused(invoker);

    SFCError error;
    ContentWindowSmp _bigContentWindow;

    // őg摜\RecEBhE𐶐
    _bigContentWindow = ContentWindow::NewInstance(&error);
    if (error == SFERR_NO_ERROR) {
        // RecEBhẼL[nhœo^
        error = _bigContentWindow->RegisterHandler(SFXEventRange(SFEVT_KEY, SFEVT_KEY, SFP16_BEGIN, SFP16_END),
                                                   XANDLER_INTERNAL(OnKey));
        if (error == SFERR_NO_ERROR) {
            // RecEBhE̐eCEBhEɐݒ肷
            error = _bigContentWindow->SetParent(GetThis());
            if (error == SFERR_NO_ERROR) {
                // RecEBhE̎̈CEBhẼ[J̈ɐݒ肷
                _bigContentWindow->SetRealBound(GetLocalBound());
                // RecEBhȄԂu{{\{tH[JXvɂ܂Ƃ߂Đݒ肷
                _bigContentWindow->SetState(true,true,true,true);
                // RecEBhEɕ\y[Wԍݒ肷
                _bigContentWindow->SetPage(page_number);
                // RecEBhEőOʂɈړ
                _bigContentWindow->ToFront();
            }
        }
    }
}

// őg摜\RecEBhẼL[nh
XANDLER_IMPLEMENT_BOOLEVENT(MainWindow, OnKey, invoker, event)
{
    UInt16 key = event.GetP16();
    switch (key) {
        // ZNgL[܂̓NAL[ꂽƂ
        case AVK_SELECT:
        case AVK_CLR:
            // RecEBhEj
            invoker->Terminate();
            //ugv{^ɃtH[JX߂
            _buttonZoom->SetStateFocus(true);
            return true;
    }
    return true;
}
